config/routes.rb
Rails.application.routes.draw do
  resources :articles
  resources :categories
  resources :vats
  resources :projects
  resources :users
  resources :interventions
  resources :partners

  root 'partners#index'

  resource :user_sessions, only: [:create, :new, :destroy]

  get 'logout' => 'user_sessions#destroy', :as => :logout

  get 'login' => 'user_sessions#login', :as => :login

  post 'get_token' => 'user_sessions#get_token'

  get 'partners/:id/interventions' => 'partners#interventions'

	get 'partners/:id/projects' => 'partners#projects'

  get 'users/:id/interventions' => 'users#interventions'

  get 'config/' => 'config#index'

  get 'about/' => 'about#index'

end

app/models/intervention.rb
class Intervention < ActiveRecord::Base
  validates :partner_id, :presence => true
  validates :user_id, :presence => true
  belongs_to :project
  belongs_to :user
  has_and_belongs_to_many :users
  has_and_belongs_to_many :articles, join_table: :interventions_lines
	has_many :interventions_lines
  has_attached_file :signature, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/missing.png"
  validates_attachment_content_type :signature, :content_type => /\Aimage\/.*\Z/

  def partner
    return self.project ? self.project.partner : nil
  end
end

app/controllers/interventions_controller.rb
class InterventionsController < ApplicationController
  before_action :set_intervention, only: [:show, :edit, :update, :destroy]
  before_action :get_partners, only: [:edit, :new, :create]
  skip_before_action :verify_authenticity_token, only: [:create, :update]

  # GET /interventions
  # GET /interventions.json
  def index
    @interventions = Intervention.order("intervention_date DESC")
    @titre = "Interventions"
    @accounted = !params["accounted"].nil?
    if params["accounted"]=="1"
      @titre += " comptabilisées"
      @interventions = @Interventions.where(compta: true)
    elsif params["accounted"]=="0"
      @titre += " à comptabiliser"
      @interventions = @interventions.where(accounted: false, billable: true).where.not(duration: nil)
    end
    @tempsTotal = 0
    @interventions.each do |intervention|
      @tempsTotal += intervention.duration.to_f
    end
  end

  # GET /interventions/1
  # GET /interventions/1.json
  def show
  end

  # GET /interventions/new
  def new
    @intervention = Intervention.new
  end

  # GET /interventions/1/edit
  def edit
  end

  # POST /interventions
  # POST /interventions.json
  def create
    @intervention = Intervention.new(intervention_params)
    user_id = params["user_credentials"] ? get_user_from_token(params["user_credentials"]).id : @current_user.id
    @intervention.user_id = user_id
    respond_to do |format|
      if @intervention.save
        format.html { redirect_to interventions_path, notice: "L'intervention a été créé." }
        format.json { render :show, status: :created, location: @intervention }
      else
        format.html { render :new }
        format.json { render json: @intervention.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /interventions/1
  # PATCH/PUT /interventions/1.json
  def update
    respond_to do |format|
      if @intervention.update(intervention_params)
        format.html { redirect_to interventions_path, notice: "L'intervention a été modifiée." }
        format.json { render :show, status: :ok, location: @intervention }
      else
        format.html { render :edit }
        format.json { render json: @intervention.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /interventions/1
  # DELETE /interventions/1.json
  def destroy
    @intervention.destroy
    respond_to do |format|
      format.html { redirect_to intervention_url, notice: "L'intervention a été supprimée." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_intervention
      @intervention = Intervention.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def intervention_params
      params.require(:intervention).permit(:project_id, :intervention_date, :duration, :accounted, :details, :comment, :billable, :state, :partner_id)
    end

    def get_partners
      @partners = Partner.order(:name)
    end
end

app/helpers/interventions_helper.rb
module InterventionsHelper
end

app/views/interventions/_form.html.erb
<%= javascript_include_tag "interventions" %>

<%= form_for(@intervention) do |f| %>

	<% if @intervention.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@intervention.errors.count, "error") %> prohibited this intervention from being saved:</h2>

      <ul>
      <% @intervention.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

	<div class="titre_actif">
		<div class="toolbar">
			<%= button_tag "", type: "submit", class: "btn btn-primary fa fa-save fa-3x save-button", title: "Enregistrer" %>
		</div>

		<h1>Intervention</h1>
		<span class="title-tag">
			<i class="fa fa-clock-o fa-4x"></i>
		</span>
	</div>

	<div class="col-md-6">
		<div class="field input-group">
			<div class="control-group">
			  <div class="field input-group">
					<span class="input-group-addon" title="Partenaire"><i class="fa fa-user fa-fw"></i> Client</span>
		      <%= f.select(:partner_id, [], {}, class: "form-control", readonly: @intervention.accounted, onchange: "populate_projects(this);" ) do %>
						<%= content_tag(:option, "", value: nil) %>
		        <% @partners.each do |partner| %>
		          <%= content_tag(:option, partner.name, value: partner.id, selected: (partner.id==@intervention.partner_id)) %>
		        <% end %>
		  		<% end %>
		    </div>
		  </div>
		</div>
	</div>
	<div class="col-md-6">
		<div class="field input-group">
			<div class="control-group">
				<div class="field input-group">
					<span class="input-group-addon"><i class="fa fa-euro fa-fw"></i> Date demande</span>
					<%= f.text_field :intervention_date, class: "datetimepicker form-control", placeholder: "Date de la demande", readonly: @intervention.state>1, value: @intervention.request_date ? @intervention.request_date.strftime("%d/%m/%Y %H:%M") : DateTime.now.strftime("%d/%m/%Y %H:%M") %>
				</div>
			</div>
		</div>
	</div>
	<div class="col-md-12">
	  <div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Projet"><i class="fa fa-user fa-fw"></i> Projet</span>
	      <%= f.select(:project_id, [], {}, class: "form-control", readonly: @intervention.accounted, onchange: "change_facturable(this);" ) do %>
					<% if @intervention.partner %>
						<% @intervention.partner.projects.each do |project| %>
							<%= content_tag(:option, project.title, value: project.id, selected: (project.id==@intervention.project_id)) %>
						<% end %>
					<% end %>
				<% end %>
	    </div>
	  </div>
		<div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Description"><i class="fa fa-pencil fa-fw"></i> Demande</span>
	      <%= f.text_area :request, class: "form-control", readonly: @intervention.request %>
	    </div>
	  </div>
	  <div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Date de début"><i class="fa fa-calendar fa-fw"></i> Date prévue</span>
	      <%= f.text_field :intervention_date, class: "datetimepicker form-control", placeholder: "Date prévue", readonly: @intervention.state>1, value: @intervention.expected_date ? @intervention.expected_date.strftime("%d/%m/%Y %H:%M") : DateTime.now.strftime("%d/%m/%Y %H:%M") %>
	    </div>
	  </div>
	</div>
	<div class="col-md-6">
		<div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Date de début"><i class="fa fa-calendar fa-fw"></i> Date intervention</span>
	      <%= f.text_field :intervention_date, class: "datetimepicker form-control", placeholder: "Date prévue", readonly: @intervention.state>1, value: @intervention.expected_date ? @intervention.expected_date.strftime("%d/%m/%Y %H:%M") : DateTime.now.strftime("%d/%m/%Y %H:%M") %>
	    </div>
	  </div>
	</div>
	<div class="col-md-6">
	  <div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Date de fin"><i class="fa fa-clock-o fa-fw"></i> Durée (en h)</span>
	      <%= f.text_field :duration, class: "form-control", placeholder: "Durée", readonly: @intervention.state>2, value: @intervention.duration.to_f %>
	    </div>
	  </div>
	</div>
	<div class="col-md-12">
	  <div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Description"><i class="fa fa-pencil fa-fw"></i> Détails intervention</span>
	      <%= f.text_area :details, class: "form-control", readonly: @intervention.state>2 %>
	    </div>
	  </div>
	  <div class="control-group">
		  <div class="field input-group">
				<span class="input-group-addon" title="Commentaire"><i class="fa fa-pencil fa-fw"></i> Commentaires</span>
	      <%= f.text_area :comment, class: "form-control", readonly: @intervention.state>2 %>
	    </div>
	  </div>
	  <div class="control-group">
			<div class="field input-group">
        <strong>Facturable ?</strong>
        <%= f.check_box :billable, value: @intervention.billable  ? 1 : 0, class: "my-checkbox" %><br>
      </div>
	  </div>

	  <% if @intervention.accounted %>
	    <div class="control-group">
	  	  <div class="field input-group">
	        <span class="input-group-addon"><%= f.check_box :accounted %></span>
	        <%= f.label "Comptabilisée", class: "form-control" %>
	    </div>
	  <% end %>

	</div>

<% end %>

app/views/interventions/_tables_interventions.html.erb
<table id="table2"
     data-classes="table table-hover table-condensed"
     data-striped="true"
     data-toolbar="#toolbar"
     data-pagination="true"
     data-click-to-select="false"
     data-search="true"
     data-show-export="true"
     data-reorderable-columns="true"
     data-show-refresh="true"
     data-show-pagination-switch="true">
  <thead>
    <tr>
      <% unless @whithoupartner %>
        <th>Client</th>
      <% end %>
      <th>Projet/Contrat</th>
      <th>Technicien</th>
      <th>Date et heure</th>
      <th>Durée</th>
      <% if @accounted %>
        <th>Comptabilisé ?</th>
      <% else %>
        <th>Facturable ?</th>
      <% end %>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @interventions.each do |intervention| %>
      <tr>
        <% unless @whithoupartner %>
          <td>
            <% if intervention.partner %>
              <%= intervention.partner.name %>
              <span class="cell-icon">
                <a href="<%= partner_path(intervention.partner) %>"><i class="fa fa-external-link"></i></a>
              </span>
            <% end %>
          </td>
        <% end %>
        <td>
          <%= intervention.project && intervention.project.title %>
          <span class="cell-icon">
            <%= link_to intervention.project do %>
              <i class="fa fa-external-link fa-fw"></i>
            <% end %>
          </span>
        </td>
        <td>
          <% if intervention.user %>
            <%= intervention.user.name %>
            <span class="cell-icon">
              <a href="<%= user_path(intervention.user) %>"><i class="fa fa-external-link"></i></a>
            </span>
          <% end %>
        </td>
        <td><%= intervention.intervention_date.strftime("%d/%m/%Y à %Hh%M") if intervention.intervention_date %></td>
        <td><%= intervention.duration.to_f.round(2) %></td>
        <% if @accounted %>
          <td align="center">
            <% classe = intervention.accounted ? "fa fa-check" : "fa fa-money" %>
            <i id="buttonComptabilise<%=intervention.id%>" class="<%= classe %>" onclick="comptabilise(<%= intervention.id %>)"></i>
          </td>
        <% else %>
          <td><i class='<%= intervention.billable ? "fa fa-check fa-fw" : "" %>'></i></td>
        <% end %>
        <td align="right">
          <%= link_to edit_intervention_path(intervention) do %>
            <i class="fa fa-pencil fa-fw"></i>
          <% end %>
          <%= link_to intervention, method: :delete, data: { confirm: 'Etes-vous sûr de vouloir supprimer cette feuille ?' } do %>
            <i class="fa fa-trash fa-fw"></i>
          <% end %>
        </td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/interventions/edit.html.erb
<%= render 'form' %>

app/views/interventions/index.html.erb
<div class="titre_actif">
  <div class="toolbar">
    <% unless @accounted %>
      <%= link_to new_intervention_path, class: "btn btn-primary" do %>
        <i class="fa fa-plus fa-3x"></i>
      <% end %>
    <% end %>
  </div>
  <h1><%= @titre %></h1>
  <span class="title-tag">
    <% if @accounted %>
    <i class="fa fa-calculator fa-4x"></i>
    <% else %>
    <i class="fa fa-clock-o fa-4x"></i>
    <% end %>
  </span>
</div>

<%= render 'tables_interventions' %>

<% if @accounted %>
  <div class="well left">
    Temps total à facturer: <%= @tempsTotal %>
  </div>
<% end %>

app/views/interventions/new.html.erb
<%= render 'form' %>

app/views/interventions/show.html.erb
<p>
  <strong>partner:</strong>
  <%= @intervention.partner %>
</p>

<p>
  <strong>Start date:</strong>
  <%= @intervention.intervention_date %>
</p>

<p>
  <strong>Durée:</strong>
  <%= @intervention.duration %>
</p>

<p>
  <strong>Compta:</strong>
  <%= @intervention.compta %>
</p>

<p>
  <strong>Description:</strong>
  <%= @intervention.details %>
</p>

<p>
  <strong>Comment:</strong>
  <%= @intervention.comment %>
</p>

<%= link_to 'Edit', edit_intervention_path(@intervention) %> |
<%= link_to 'Back', intervention_path %>